2 ##############################################################################
3 # Copyright (c) 2015 Ericsson AB and others.
4 # jose.lausuch@ericsson.com
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
13 echo "usage: $0 [-v] -d <destination> -i <installer_type> -a <installer_ip>" >&2
14 echo "[-v] Virtualized deployment" >&2
18 logger -s -t "fetch_os_creds.info" "$*"
23 logger -s -t "fetch_os_creds.error" "$*"
28 verify_connectivity() {
30 info "Verifying connectivity to $ip..."
31 for i in $(seq 0 10); do
32 if ping -c 1 -W 1 $ip > /dev/null; then
33 info "$ip is reachable!"
38 error "Can not talk to $ip."
44 while getopts ":d:i:a:h:v" optchar; do
46 d) dest_path=${OPTARG} ;;
47 i) installer_type=${OPTARG} ;;
48 a) installer_ip=${OPTARG} ;;
49 v) DEPLOY_TYPE="virt" ;;
50 *) echo "Non-option argument: '-${OPTARG}'" >&2
57 # set vars from env if not provided by user as options
58 dest_path=${dest_path:-$HOME/opnfv-openrc.sh}
59 installer_type=${installer_type:-$INSTALLER_TYPE}
60 installer_ip=${installer_ip:-$INSTALLER_IP}
62 if [ -z $dest_path ] || [ -z $installer_type ] || [ -z $installer_ip ]; then
67 # Checking if destination path is valid
68 if [ -d $dest_path ]; then
69 error "Please provide the full destination path for the credentials file including the filename"
71 # Check if we can create the file (e.g. path is correct)
72 touch $dest_path || error "Cannot create the file specified. Check that the path is correct and run the script again."
76 ssh_options="-o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"
78 # Start fetching the files
79 if [ "$installer_type" == "fuel" ]; then
81 verify_connectivity $installer_ip
83 env=$(sshpass -p r00tme ssh 2>/dev/null $ssh_options root@${installer_ip} \
84 'fuel env'|grep operational|head -1|awk '{print $1}') &> /dev/null
86 error "No operational environment detected in Fuel"
88 env_id="${FUEL_ENV:-$env}"
90 # Check if controller is alive (online='True')
91 controller_ip=$(sshpass -p r00tme ssh 2>/dev/null $ssh_options root@${installer_ip} \
92 "fuel node --env ${env_id} | grep controller | grep 'True\| 1' | awk -F\| '{print \$5}' | head -1" | \
93 sed 's/ //g') &> /dev/null
95 if [ -z $controller_ip ]; then
96 error "The controller $controller_ip is not up. Please check that the POD is correctly deployed."
99 info "Fetching rc file from controller $controller_ip..."
100 sshpass -p r00tme ssh 2>/dev/null $ssh_options root@${installer_ip} \
101 "scp $ssh_options ${controller_ip}:/root/openrc ." &> /dev/null
102 sshpass -p r00tme scp 2>/dev/null $ssh_options root@${installer_ip}:~/openrc $dest_path &> /dev/null
104 #This file contains the mgmt keystone API, we need the public one for our rc file
105 admin_ip=$(cat $dest_path | grep "OS_AUTH_URL" | sed 's/^.*\=//' | sed "s/^\([\"']\)\(.*\)\1\$/\2/g" | sed s'/\/$//')
106 public_ip=$(sshpass -p r00tme ssh $ssh_options root@${installer_ip} \
107 "ssh ${controller_ip} 'source openrc; openstack endpoint list --long'" \
108 | grep $admin_ip | sed 's/ /\n/g' | grep ^http | head -1) &> /dev/null
109 #| grep http | head -1 | cut -d '|' -f 4 | sed 's/v1\/.*/v1\//' | sed 's/ //g') &> /dev/null
110 #NOTE: this is super ugly sed 's/v1\/.*/v1\//'OS_AUTH_URL
111 # but sometimes the output of endpoint-list is like this: http://172.30.9.70:8004/v1/%(tenant_id)s
112 # Fuel virtual need a fix
114 if [ "$DEPLOY_TYPE" == "virt" ]; then
115 echo "INFO: Changing: internalURL -> publicURL in openrc"
116 sed -i 's/internalURL/publicURL/' $dest_path
119 elif [ "$installer_type" == "apex" ]; then
120 verify_connectivity $installer_ip
122 # The credentials file is located in the Instack VM (192.0.2.1)
123 # NOTE: This might change for bare metal deployments
124 info "Fetching rc file from Instack VM $installer_ip..."
125 if [ -f /root/.ssh/id_rsa ]; then
126 chmod 600 /root/.ssh/id_rsa
128 sudo scp $ssh_options root@$installer_ip:/home/stack/overcloudrc $dest_path
130 elif [ "$installer_type" == "compass" ]; then
131 verify_connectivity $installer_ip
132 controller_ip=$(sshpass -p'root' ssh 2>/dev/null $ssh_options root@${installer_ip} \
133 'mysql -ucompass -pcompass -Dcompass -e"select * from cluster;"' \
134 | awk -F"," '{for(i=1;i<NF;i++)if($i~/\"host[1-5]\"/) {print $(i+1);break;}}' \
135 | grep -oP "\d+.\d+.\d+.\d+")
137 if [ -z $controller_ip ]; then
138 error "The controller $controller_ip is not up. Please check that the POD is correctly deployed."
141 info "Fetching rc file from controller $controller_ip..."
142 sshpass -p root ssh 2>/dev/null $ssh_options root@${installer_ip} \
143 "scp $ssh_options ${controller_ip}:/opt/admin-openrc.sh ." &> /dev/null
144 sshpass -p root scp 2>/dev/null $ssh_options root@${installer_ip}:~/admin-openrc.sh $dest_path &> /dev/null
146 info "This file contains the mgmt keystone API, we need the public one for our rc file"
147 public_ip=$(sshpass -p root ssh $ssh_options root@${installer_ip} \
148 "ssh ${controller_ip} 'source /opt/admin-openrc.sh; openstack endpoint show identity '" \
149 | grep publicurl | awk '{print $4}')
150 info "public_ip: $public_ip"
153 elif [ "$installer_type" == "joid" ]; then
154 # do nothing...for the moment
155 # we can either do a scp from the jumphost or use the -v option to transmit the param to the docker file
156 echo "Do nothing, creds will be provided through volume option at docker creation for joid"
158 elif [ "$installer_type" == "foreman" ]; then
159 #ip_foreman="172.30.10.73"
160 controller="oscontroller1.opnfv.com"
161 verify_connectivity $installer_ip
163 # Check if controller is alive (here is more difficult to get the ip from a command like "fuel node")
164 sshpass -p vagrant ssh $ssh_options root@${installer_ip} \
165 "sshpass -p Op3nStack ssh $ssh_options root@${controller} 'ls'" &> /dev/null
166 if [ $? -ne 0 ]; then
167 error "The controller ${controller} is not up. Please check that the POD is correctly deployed."
170 info "Fetching openrc from a Foreman Controller '${controller}'..."
171 sshpass -p vagrant ssh $ssh_options root@${installer_ip} \
172 "sshpass -p Op3nStack scp $ssh_options root@${controller}:~/keystonerc_admin ." &> /dev/null
173 sshpass -p vagrant scp $ssh_options root@${installer_ip}:~/keystonerc_admin $dest_path &> /dev/null
175 #This file contains the mgmt keystone API, we need the public one for our rc file
176 admin_ip=$(cat $dest_path | grep "OS_AUTH_URL" | sed 's/^.*\=//' | sed "s/^\([\"']\)\(.*\)\1\$/\2/g" | sed s'/\/$//')
177 public_ip=$(sshpass -p vagrant ssh $ssh_options root@${installer_ip} \
178 "sshpass -p Op3nStack ssh $ssh_options root@${controller} \
179 'source keystonerc_admin;keystone endpoint-list'" \
180 | grep $admin_ip | sed 's/ /\n/g' | grep ^http | head -1) &> /dev/null
183 error "Installer $installer is not supported by this script"
187 if [ ! -f $dest_path ]; then
188 error "There has been an error retrieving the credentials"
191 if [ "$public_ip" != "" ]; then
192 info "Exchanging keystone public IP in rc file to $public_ip"
193 sed -i "/OS_AUTH_URL/c\export OS_AUTH_URL=\'$public_ip'" $dest_path
198 echo "-------- Credentials: --------"